<?php
/**
 * @version		$Id: table.php 20196 2011-01-26 12:42:15Z donpool $
 * @package		JeTs.Framework
 * @subpackage	Table
 * @copyright	Copyright (C) 2006 - 2011 NawesCorp. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('JPATH_BASE') or die;

abstract class JeTsTable extends JTable {
	
	function __construct($table, $key, &$db) {
		parent::__construct( $table, $key, $db );
	}

	/**
	 * Returns all the table records for this table
	 *
	 * @param string $where clause (can include ORDER BY and LIMIT)
	 * @return array of table-row objects or false if error
	 */
	function getAll( $where = '1' ) {
		$this->reset();

		$db =& $this->getDBO();

		$query = $this->buildQuery( $where );
		$db->setQuery( $query );

		if ($result = $db->loadObjectList()) {
			return $result;
		}
		else
		{
			$this->setError( $db->getErrorMsg() );
			return false;
		}
	}
	
	/**
	 * Buils the query being used to getAll()
	 *
	 * @param string $where clause (can include ORDER BY and LIMIT)
	 * @return string of built query
	 */
	function buildQuery( $where = '1' ) {
		$query = 'SELECT *'
		. ' FROM '.$this->_tbl
		. ' WHERE '.$where;
		
		return $query;
	}
	
}
